<script setup lang="ts">
import { LIcon, LMarker } from "@vue-leaflet/vue-leaflet";
import { ref } from "vue";
import Interventions from "../types/intervention";

definePageMeta({
  layout: "decorated",
  middleware: "authentication",
});

// Récupération des droits :
const token = getToken() ?? "";
const decodedToken = getDecodedToken(token);

// Affiche la modale
let showModal: Ref<boolean> = ref(false);

const { baseURL } = useRuntimeConfig().app;
const authorizationHeader = useAuthorizationHeader("application/json");

// Récupération des interventions :
/**
 * Renvoie l'URL pour récupérer les interventions
 * en fonction de l'utilisateur.
 * @param {Array} roles les rôles.
 * @param {number} userId l'identifiant de l'utilisateur.
 * @returns {string} l'URL pour récupérer les interventions.
 */
function getFetchInterventionsURL(
  roles: Array,
  userId: Number,
  employerId: Number
): string {
  if (roles.includes("ROLE_READ_EMPLOYER_INTERVENTIONS")) {
    return (
      baseURL +
      "api/employers/" +
      employerId +
      "/interventions?order[id]=desc&status.slug[]=to-do&status.slug[]=in-progress&status.slug[]=blocked&status.slug[]=not-assigned"
    );
  }
  
  if (roles.includes("ROLE_READ_ASSIGNED_TO_ME_INTERVENTIONS")) {
    return (
      baseURL +
      "api/users/" +
      userId +
      "/interventions?order[id]=desc&status.slug[]=to-do&status.slug[]=in-progress&status.slug[]=blocked&status.slug[]=not-assigned"
    );
  }

  return "";
}

const { data: responseInterventions } = await useFetch<Interventions[]>(
  getFetchInterventionsURL(
    decodedToken.roles,
    decodedToken.userId,
    decodedToken.employerId
  ),
  {
    headers: authorizationHeader,
  }
);
const interventions = ref(responseInterventions.value.interventions);
const interventionsCount = ref(responseInterventions.value.total);

let selectedIntervention = ref(null);
const handleClickPin = (intervention) => {
  selectedIntervention.value = intervention;
};

/**
 * Renvoie l'URL de l'intervention.
 * @param {string} statusSlug le nom du statut.
 * @param {number} interventionId l'identifiant de l'intervention.
 * @returns {string} l'URL de l'intervention.
 */
function getInterventionLink(
  statusSlug: string,
  interventionId: number
) {
  switch (statusSlug) {
    case "not-assigned":
      return baseURL + "interventions/" + interventionId;
    case "to-do":
      return baseURL + "interventions/" + interventionId;
    case "in-progress":
      return baseURL + "interventions/" + interventionId + "/encours";
    case "blocked":
      return baseURL + "interventions/" + interventionId + "/attente";
    case "finished":
      return baseURL + "interventions/" + interventionId + "/terminee";
  }
}

// Récupération des coordonnées de l'employeur :
const employer = await useFetchEmployerCoordinates();
const latLng = ref([employer.latitude, employer.longitude]);

/**
 * Géolocalise l'utilisateur.
 */
function useGeolocation() {
  navigator.geolocation.getCurrentPosition(onSuccessGeolocation, null, {
    enableHighAccuracy: true,
  });
}

/**
 * Lorsque l'on détecte la position.
 * @param {any} position la position.
 */
function onSuccessGeolocation(position: any) {
  latLng.value = [position.coords.latitude, position.coords.longitude];
}
</script>

<template>
  <!-- <Nav /> -->

  <section>
    <button
      @click="showModal = true"
      class="fr-icon-list-unordered fr-p-1w button-list"
    ></button>

    <Modal :show="showModal" @close="showModal = false">
      <template #modal-header>
        <h1 class="fr-ml-13w">Interventions</h1>
      </template>
      <!-- <Nav /> -->
      <div class="fr-pt-2w fr-px-2w list-inter">
        <p>{{ interventionsCount }} interventions</p>
        <ul class="fr-py-2w">
          <li v-for="intervention in interventions" :key="intervention.id">
            <nuxt-link
              :to="
                getInterventionLink(intervention.status.slug, intervention.id)
              "
            >
              <div class="fr-card fr-card--horizontal fr-mb-2w intervention">
                <div class="fr-card__body fr-pr-0">
                  <div class="fr-card__content fr-pl-2w fr-py-0">
                    <div class="fr-pt-2w">
                      <p
                        :class="[
                          'fr-tag fr-mr-1v',
                          { urgent: intervention.priority.slug === 'urgent' },
                        ]"
                      >
                        {{ intervention.priority.name }}
                      </p>
                      <p
                        :class="[
                          'fr-badge fr-badge--no-icon',
                          {
                            'fr-badge--new':
                              intervention.status.name === 'À faire',
                            'fr-badge--info':
                              intervention.status.name === 'En cours',
                            'fr-badge--warning':
                              intervention.status.name === 'Bloquée',
                            'fr-badge--error':
                              intervention.status.name === 'Annulée',
                            'fr-badge--success':
                              intervention.status.name === 'Terminée',
                          },
                        ]"
                      >
                        {{ intervention.status.name }}
                      </p>
                    </div>
                    <p
                      class="fr-card__detail fr-icon-arrow-right-line fr-mt-1v"
                    >
                      Postée {{ useFormatDate(intervention.createdAt) }}
                    </p>

                    <h3 class="fr-card__title fr-mb-2w">
                      {{ intervention.location.rest }}
                      {{ intervention.location.street }} <br />
                      {{ intervention.location.postcode }}
                      {{ intervention.location.city }}
                    </h3>
                  </div>
                </div>

                <div class="fr-card__header">
                  <div
                    class="fr-card__img"
                    v-if="intervention.pictures.length >= 1"
                  >
                    <img
                      class="fr-responsive-img"
                      :src="intervention.pictures[0].URL"
                      :alt="`${intervention.pictures[0].tags[0].name} intervention`"
                    />
                  </div>
                  <div
                    class="fr-card__img"
                    v-else="intervention.pictures === 0"
                  >
                    <img
                      class="fr-responsive-img"
                      :src="intervention.type.picture"
                      :alt="`${intervention.type.picture}`"
                    />
                  </div>
                </div>
              </div>
            </nuxt-link>
          </li>
        </ul>
      </div>
    </Modal>

    <Map :lat-lng="latLng" :zoom="14" class="map">
      <LMarker :lat-lng="latLng">
        <LIcon :icon-url="baseURL + 'img/current-location-marker.png'" />
      </LMarker>

      <LMarker
        v-for="intervention in interventions"
        :lat-lng="[
          intervention.location.latitude,
          intervention.location.longitude,
        ]"
        :key="intervention.id"
        @click="handleClickPin(intervention)"
      >
        <LIcon :icon-url="usePinPicture(intervention.priority.slug)" />
      </LMarker>
    </Map>

    <section v-if="selectedIntervention">
      <div class="modal-overlay fr-mx-2w" @click="selectedIntervention = null">
        <nuxt-link
          :to="
            getInterventionLink(
              selectedIntervention.status.slug,
              selectedIntervention.id
            )
          "
        >
          <div class="fr-card fr-card--horizontal intervention">
            <div class="fr-card__body fr-pr-0">
              <div class="fr-card__content fr-pl-2w fr-py-0">
                <div class="fr-pt-2w">
                  <p
                    :class="[
                      'fr-tag fr-mr-1v',
                      {
                        urgent: selectedIntervention.priority.slug === 'urgent',
                      },
                    ]"
                  >
                    {{ selectedIntervention.priority.name }}
                  </p>
                  <p
                    :class="[
                      'fr-badge fr-badge--no-icon',
                      {
                        'fr-badge--new':
                          selectedIntervention.status.name === 'À faire',
                        'fr-badge--info':
                          selectedIntervention.status.name === 'En cours',
                        'fr-badge--warning':
                          selectedIntervention.status.name === 'Bloquée',
                        'fr-badge--error':
                          selectedIntervention.status.name === 'Annulée',
                        'fr-badge--success':
                          selectedIntervention.status.name === 'Terminée',
                      },
                    ]"
                  >
                    {{ selectedIntervention.status.name }}
                  </p>
                </div>
                <p class="fr-card__detail fr-icon-arrow-right-line fr-mt-1v">
                  Postée {{ useFormatDate(selectedIntervention.createdAt) }}
                </p>

                <h3 class="fr-card__title fr-mb-2w">
                  {{ selectedIntervention.location.rest }}
                  {{ selectedIntervention.location.street }} <br />
                  {{ selectedIntervention.location.postcode }}
                  {{ selectedIntervention.location.city }}
                </h3>
              </div>
            </div>

            <div class="fr-card__header">
              <div
                class="fr-card__img"
                v-if="selectedIntervention.pictures.length >= 1"
              >
                <img
                  class="fr-responsive-img"
                  :src="selectedIntervention.pictures[0].URL"
                  :alt="`${selectedIntervention.pictures[0].tags[0].name} intervention`"
                />
              </div>
              <div
                class="fr-card__img"
                v-else="selectedIntervention.pictures === 0"
              >
                <img
                  class="fr-responsive-img"
                  :src="selectedIntervention.type.picture"
                  :alt="`${selectedIntervention.type.picture}`"
                />
              </div>
            </div>
          </div>
        </nuxt-link>
      </div>
    </section>

    <a
      v-if="decodedToken.roles.includes('ROLE_INTERVENTIONS_POST')"
      class="fr-btn fr-p-5v button-add"
      href="interventions/creer"
    >
      <span class="fr-icon-add-line"></span>
    </a>

    <button
      type="button"
      class="button-geo fr-grid-row fr-grid-row--middle fr-grid-row--center"
      @click.stop="useGeolocation"
    >
      <span class="fr-icon-send-plane-line"></span>
    </button>
  </section>
</template>

<style scoped>
section {
  position: relative;
}

.map {
  height: calc(100vh - var(--height-header) - 56px);
}

.button-add {
  border-radius: 40%;
  position: absolute;
  bottom: 8.5vh;
  left: 41.5%;
  height: 4rem;
  box-shadow: 0px 10px 10px -6px #666;
}

.button-geo {
  border-radius: 63px;
  background: var(--background-default-grey);
  color: var(--background-active-blue-france);
  position: absolute;
  bottom: 10vh;
  right: 1.5rem;
  height: 2.5rem;
  width: 2.5rem;
  box-shadow: 0px 10px 10px -6px #666;
}

.button-list {
  position: absolute;
  right: 20px;
  top: 20px;
  z-index: 1;
  background-color: var(--background-default-grey);
  color: var(--background-active-blue-france);
  box-shadow: 0 0 0 2px var(--border-default-grey);
  border-radius: 100px;
}

.list-inter {
  background-color: #f6f6f6;
}

.intervention {
  flex-direction: row-reverse;
  align-items: center;
  flex-wrap: nowrap;
}

h3 {
  font-size: 0.875rem !important;
}

li {
  list-style: none;
}

.fr-tag {
  background-color: var(--background-action-low-blue-france);
  color: var(--text-action-high-blue-france);
}

.urgent {
  background-color: var(--background-action-high-warning);
  color: var(--text-inverted-blue-france);
}

.modal-overlay {
  position: absolute;
  left: 0;
  right: 0;
  bottom: calc(16vh + 1.5rem);
  z-index: 999;
}

.modal-content {
  position: relative;
  background-color: white;
}

.modal-content .fr-grid-row {
  margin-bottom: 20px;
}

.modal-content .fr-card__header {
  width: 50%;
}

.modal-content .fr-card__img {
  max-width: 100%;
  height: auto;
}

.modal-content button {
  position: absolute;
  bottom: 20px;
  right: 20px;
}

.fr-card:not(.fr-card--no-border):not(.fr-card--shadow) {
  box-shadow: 0 0 0 0 var(--border-default-grey);
}

.fr-card__header img {
  height: 147px;
  width: 147px;
}
.fr-badge {
  font-size: 0.7rem;
}
</style>
